#!/usr/bin/perl

# **
# * ------------------------------------------------------------------------
# * BlueMind Stats Portal, aka bm-stats
# * ------------------------------------------------------------------------
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
# * @author  : Pascal SALAUN 
# * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
# * ------------------------------------------------------------------------
# **

BEGIN {
    push @INC,"/usr/share/bm-stats/scripts/PERL/";
};

require "bmFunctions.pl";

#use strict;
use List::Util qw(sum);
use Date::Calc qw(Week_Number Mktime);
use Encode ;
use File::Path ;
use File::Copy ;
use Data::Dumper qw(Dumper) ;


my $spoolCyrusPath = '/var/spool/cyrus' ;
my $path_to_data_dir = "/var/lib/bm-stats/" ;



my $domain       = '' ;
my $mailbox      = '' ;
my $quota        = '' ;
my $linePHP      = '' ;
my $lineDu       = '' ;
my $mboxDirSpace = '' ;
my $nbElement    = '' ;
my $maxElement   = '' ;


my @allMailbox = () ;
my @linePHP    = () ;
my @lineDu     = () ;
my @historyKey = () ;


my %history    = () ;


my %globalArray = () ;
push @{$globalArray{'Global'}{'mailboxDirSpaceUsed'}}, 0 ; 

# Get set quota in Ko
@allMailbox= split (/ /,`/usr/bin/php5 /usr/share/bm-stats/scripts/PHP/api/listAllMailboxQuota.php`) ;

foreach $linePHP (@allMailbox) {

    ($domain,$mailbox,$quota) = split(",",$linePHP) ;

    # Users values    
    $globalArray{$domain}{$mailbox}{'quota'} = $quota ;
    $globalArray{$domain}{$mailbox}{'mailboxDirSpaceUsed'} = '0' ;    
    
    # Domain values init
    push @{$globalArray{$domain}{'mailboxDirSpaceUsed'}}, 0 ;
};


# Get mbox dir size in Ko
my @lineDu =  `du --max-depth=7 --exclude="cyrus.*" $spoolCyrusPath | grep user/. | sort` ;
foreach $lineDu (@lineDu) { 

    chomp($lineDu);
    #17388    /var/spool/cyrus/mclabosse_fr/domain/m/mclabosse.fr/p/user/pascal^salaun
    $lineDu =~ s/\t// ;
    $lineDu =~ s/\^/\./ ;  
    $lineDu =~ s/_/\./ ;
    $lineDu =~ s/${spoolCyrusPath}// ;
    
    #17388/mclabosse.fr/domain/m/mclabosse.fr/p/user/pascal.salaun    
    my @trash = split("/", $lineDu) ;
    $quota   = $trash[0];
    $domain  = $trash[1];
    $mailbox = $trash[-1];

    # Users values
    $globalArray{$domain}{$mailbox}{'mailboxDirSpaceUsed'} = $quota ;
    
    # Domain and Global values
    push @{$globalArray{$domain}{'mailboxDirSpaceUsed'}}, $quota ;
    push @{$globalArray{'Global'}{'mailboxDirSpaceUsed'}}, $quota ;
};


# if parsing at 00: 
my $when = `date +%H:`;
chomp($when) ;

#init launch mktime 
my $mktime = time() ;


$nbDomain = keys %globalArray ;
$maxElement = $nbDomain*24; # 1 parse/hour * 24 hours

my $dir = $path_to_data_dir."general" ;
&control_rep($dir);
my $allDomainQuotaFile = $dir."/allDomainQuotaFile.dat" ;
my $domainQuotaFile    =  $dir."/quotaH24.dat";

# Domain survey values
my @historyKeyN = () ;
%history = () ;
%history = &readRealTimeFile($domainQuotaFile);
    
foreach my $domain (keys(%globalArray)) {
    
    $thisDomainValue = sum ( @{$globalArray{$domain}{'mailboxDirSpaceUsed'}} );
    my $thisKey = "$mktime-$domain";
    $history{$thisKey} = "$domain,$thisDomainValue";


    # Save daily domain quota
    if ($when eq "00:") { 
        # Feed the file
        print   $allDomainQuotaFile."\n" ;
        open(File,">> $allDomainQuotaFile") || die "Error while opening : $!";
        my $thisLine = "$thisKey;$domain,$thisDomainValue\n";
        print File $thisLine;
	print $thisLine;

        close(File);
    };
    

    if ($domain ne 'Global' ) {
            
        my $userDomainQuotaDir     = $path_to_data_dir.$domain."/userQuota" ;     
        my $userDomainQuotaDirFile = $path_to_data_dir.$domain."/userQuota.dat";
        &control_rep($userDomainQuotaDir);
        
        # User quota files
        # Erase old file if exists, No history on Domain     
        
        if (-f $userDomainQuotaDirFile) {
            open(FuserDomainQuotaDirFile,"> $userDomainQuotaDirFile") || die "Error while opening : $!";
            close(FuserDomainQuotaDirFile);
        } ;


        # Alim domain and user file 
        my @user = keys %{@globalArray{$domain}};
        

        open(FuserDomainQuotaDirFile,">> $userDomainQuotaDirFile") || die "Error while opening : $!";
        
        foreach my $thisUser (sort @user) {
            if( ($thisUser=~ m%[a-zA-Z0-9]+%) and ($thisUser !~ m%mailboxDirSpaceUsed%) ) {
                
                my $thisUserFile = $userDomainQuotaDir."/".$thisUser ;        
                my $thisUserLine = "$thisUser,".$globalArray{$domain}{$thisUser}{'mailboxDirSpaceUsed'}.",".$globalArray{$domain}{$thisUser}{'quota'}."\n";
                my $thisLine     = "$mktime;".$globalArray{$domain}{$thisUser}{'mailboxDirSpaceUsed'}.",".$globalArray{$domain}{$thisUser}{'quota'}."\n";
                
                open(FuserFile, ">>$thisUserFile") || die "Error while opening : $!";
                print FuserFile $thisLine ;
                print FuserDomainQuotaDirFile $thisUserLine ;
                close(FuserFile);
            };
        };
        
        close(FuserDomainQuotaDirFile) ;
    };

    
};


# Save 24hours quota/domain (rotate)
@historyKey = sort (keys %history) ;
$nbElement  = @historyKey ;

if ( $nbElement> $maxElement) {
    @historyKeyN = @historyKey[-$maxElement..-1];
} else {
       @historyKeyN = @historyKey ;
};


# Erase the file
if(-f  $domainQuotaFile) {
    open(FdomainQuotaFile,"> $domainQuotaFile") || die "Error while opening : $!";
       close(FdomainQuotaFile);
};

    
# Feed the file
open(FdomainQuotaFile,,">> $domainQuotaFile") || die "Error while opening : $!";
foreach my $key (@historyKeyN) { 
       my $thisLine = $key.";".$history{$key}."\n";
       print FdomainQuotaFile $thisLine ;
};
   
close(FdomainQuotaFile);


my $trash = `php5 /usr/share/bm-stats/scripts/PHP/do_graph/bmCyrus.php`;


